package com.hexin.android.component.listview

import android.content.Context
import androidx.recyclerview.widget.LinearLayoutManager
import androidx.recyclerview.widget.RecyclerView
import androidx.recyclerview.widget.LinearSmoothScroller

/**
 * 自定义滑动时间，避免list很长时，滑动时间过长
 */
class CustomSmoothTimeLayout(context: Context, val smoothTime: Int = 1920) : LinearLayoutManager(context) {

    override fun smoothScrollToPosition(recyclerView: RecyclerView?, state: RecyclerView.State?, position: Int) {
        recyclerView ?: return
        val linearSmoothScroller = object : LinearSmoothScroller(recyclerView.context) {
            override fun calculateTimeForScrolling(dx: Int): Int {
                var dxTemp = dx
                if (dx > smoothTime) {
                    dxTemp = smoothTime
                }
                return super.calculateTimeForScrolling(dxTemp)
            }
        }
        linearSmoothScroller.targetPosition = position
        startSmoothScroll(linearSmoothScroller)
    }
}