package com.hexin.android.component.listview

import android.view.View

/**
 * 可滑动的列表项
 */
interface SlidingItem {

    /**
     * 固定部分的宽度
     */
    fun getFixedViewWidth(): Int

    /**
     * 可以滑动的部分
     */
    fun getSlidingView(): View?

    /**
     * 在滑动时回调，包括：
     * 1、手指滑动
     * 2、惯性滑动
     */
    fun onSliding(scrollX: Int)

    /**
     * 在滑动部分停下来之前调用
     * @param scrollX 当前已经滚动的距离
     * @return 要继续滚动到的x坐标，如果为负数，则不再滚动
     */
    fun onPreIdle(scrollX: Int): Int

    /**
     * 是否允许滑动，增加这个方法便于更加灵活地赋予和移除实现SlidingItem的视图的滑动效果
     */
    fun allowToSlid(): Boolean
}